<?php
namespace DaReactions;
use Freemius_Exception;
use JetBrains\PhpStorm\NoReturn;
/**
 *
 */
class File
{
    /**
     * @param Main $main
     */
    public function __construct($main)
    {
    }
    /**
     * @throws Freemius_Exception
     */
    public function downloadCsv(): void
    {
        global $wpdb;
        $order_by = filter_input(INPUT_GET, 'orderby', FILTER_SANITIZE_FULL_SPECIAL_CHARS);
        $order = filter_input(INPUT_GET, 'order', FILTER_SANITIZE_FULL_SPECIAL_CHARS);
        $votes_table_name = Data::getVotesTable();
        if (empty($order_by)) {
            $order_by = 'ID';
        }
        if (in_array($order, array('asc', 'desc'))) {
            $order = strtoupper($order);
        } else {
            $order = 'ASC';
        }
        $date_range = filter_input(INPUT_GET, 'date-range', FILTER_SANITIZE_FULL_SPECIAL_CHARS);
        $date_clause = '';
        if (isset($this->date_range_options[$date_range])) {
            $date_clause = Data::getDateClause($date_range, 'created_at');
        }
        $filter_clause = Data::getFilterClause();
        $query = "SELECT ID,
       resource_type,
       resource_id,
       emotion_id,
       user_id,
       user_token,
       user_ip,
       created_at
       FROM $votes_table_name
       WHERE 1 = 1
       $date_clause
       $filter_clause";
        $main_query = $wpdb->prepare(
            "$query
 ORDER BY $order_by $order"
        );
        $items = $wpdb->get_results(
            $main_query,
            ARRAY_A
        );
        $out = fopen('php://output', 'wb');
        if (count($items) > 0) {
            fputcsv($out, array_keys($items[0]));
        }
        foreach ($items as $file) {
            $result = [];
            array_walk_recursive($file, static function($item) use (&$result) {
                $result[] = $item;
            });
            fputcsv($out, $result);
        }
        fclose($out);
        exit();
    }
}
